<?php
namespace Suprimentos\Logic\FornecedorPorProduto;
use Geral\Entities\Arvore;
use Geral\Entities\Arvoreforn;
use \Geral\Entities\Arvoreproduto;
use \Suprimentos\Entities\Prodforn;
use \Suprimentos\Entities\Prodforncomp;
use \Windows\WinPbi00132001\TabPbi00132001000\Exception\Exception;

class Consulta{
    public static function buscaProdutos($nrorg, $arvores){
        try {
            if (is_array($arvores)) {
                $produtos = array();

                $campos = array(1 => $nrorg, 2 => $arvores);
                $resultBusca = Arvoreproduto::getObjectsByWhere("NRORG=? AND NRARVORE IN (?)", $campos);
                foreach ($resultBusca as $object) {
                    $produtos[] = $object->getCdproduto();
                }
                return $produtos;
            }else{
                Exception::InformarProduto();
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }
    public static function buscaProdForn($nrorg, $fornecedor, $produto){
        $array=array(1 => $nrorg, 2 => $fornecedor, 3 =>$produto);
        $busca=Prodforn::getObjectByWhere("NRORG = ? AND CDFORNECED = ? AND CDPRODUTO = ?",$array);

        if(is_object($busca)){
            return $busca;
        }else{
            return false;
        }
    }
    public static function buscaProdforncomp($nrorg, $fornecedor, $produto){
        $array=array(1 => $nrorg, 2 => $fornecedor, 3 =>$produto, 4=>$produto);
        $busca=Prodforncomp::getObjectByWhere("NRORG = ? AND CDFORNECED = ? AND CDPRODUTO = ? AND CDPRODCOMPL=?",$array);

        if(is_object($busca)){
            return $busca;
        }else{
            return false;
        }
    }
    //OBRTER ARVORE FORNECEDOR
    public static function buscaArvore($nrorg){

        $array = array(1 => $nrorg, 2 => 1);
        /** @var  $object Arvoreforn*/
        $object=Arvoreforn::getObjectByWhere("NRORG=? AND ROWNUM=?",$array);

        if($object){
            $tipoArvore=$object->getNrarvore();
            return ($tipoArvore);
        }else{
            return NULL;
        }
    }
    //OBTER TIPO DE ÁRVORE
    public static function buscaTipoArvore($nrorg){
        @$arvore=self::buscaArvore($nrorg);
        if($arvore){
            $array = array(1 => $arvore, 2 => $nrorg);
            /** @var  $object Arvore */
            $object = Arvore::getObjectByWhere("NRARVORE=? AND NRORG=?", $array);

            if($object){
                $tipoArvore = $object->getCdtipoarvore();
                return ($tipoArvore);
            }else{
                return NULL;
            }
        }else{
            return NULL;
        }
    }

}