CREATE OR REPLACE PROCEDURE ARQUIVO_DMA_BA(
   P_CDIMPOSTO    IN IMPOSTO.CDIMPOSTO%TYPE,
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA   IN EMPRESA.CDINSCESTA%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_CDLIVROMAG   IN LIVROMAGNETICO.CDLIVROMAG%TYPE,
   P_RETIFIC      VARCHAR2,
   P_BAIXAEMP     VARCHAR2,
   P_INSCUNICA    VARCHAR2,
   P_CODINSP      VARCHAR2,
   P_GRUPPROD     IN PRSUBGRPROD.CDGRUPPROD%TYPE,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE,
   P_CHECKINFO    VARCHAR2 )
AS
   V_CONTADOR    NUMBER;
   V_PARAM_ESTOQ VARCHAR2(1);
BEGIN

----------------------------------------   /*REGISTROS 00 E 01*/   -------------------------------------
   V_CONTADOR := ARQUIVO_DMA_MESTRE(P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL,
                                    P_RETIFIC, P_BAIXAEMP, P_INSCUNICA, P_CODINSP, P_NRSEQARQMAG);
--------------------------------------------------------------------------------------------------------


----------------------------------------   /*REGISTROS 08 E 09*/   -------------------------------------
   V_CONTADOR := ARQUIVO_DMA_UF (P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL,
                                 P_NRSEQARQMAG);
--------------------------------------------------------------------------------------------------------


----------------------------------------   /*REGISTROS 10 E 11*/   -------------------------------------
   V_CONTADOR := ARQUIVO_DMA_OPERACAO (P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL,
                                       P_CDLIVROMAG, P_NRSEQARQMAG);
--------------------------------------------------------------------------------------------------------


----------------------------------------   /*REGISTRO 12*/   -------------------------------------------
   V_PARAM_ESTOQ := P_BAIXAEMP;
   IF ((V_PARAM_ESTOQ <> 'N') OR (P_CHECKINFO = 'S'))THEN
   V_CONTADOR := ARQUIVO_DMA_ESTOQUE (P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL,
                                      P_GRUPPROD, P_NRSEQARQMAG);
   END IF;
--------------------------------------------------------------------------------------------------------


----------------------------------------   /*REGISTROS 14 E 15*/   -------------------------------------
   V_CONTADOR := ARQUIVO_DMA_APURACAO (P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL,
                                       P_NRSEQARQMAG);
--------------------------------------------------------------------------------------------------------


----------------------------------------   /*REGISTROS 16 E 17*/   -------------------------------------
   V_CONTADOR := ARQUIVO_DMA_ICMS_ST (P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL,
                                      P_NRSEQARQMAG);
--------------------------------------------------------------------------------------------------------


----------------------------------------   /*REGISTROS 18 E 19*/   -------------------------------------
   V_CONTADOR := ARQUIVO_DMA_CREDITO (P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL,
                                      P_NRSEQARQMAG);
--------------------------------------------------------------------------------------------------------


----------------------------------------   /*REGISTROS 21 E 22*/   -------------------------------------
   V_CONTADOR := ARQUIVO_DMA_CONTADOR (P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL,
                                       P_NRSEQARQMAG);
--------------------------------------------------------------------------------------------------------


----------------------------------------   /*REGISTROS 30 E 31*/   -------------------------------------
   IF (P_INSCUNICA = 'S') THEN
   V_CONTADOR := ARQUIVO_DMA_CS (P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL,
                                 P_CDLIVROMAG, P_NRSEQARQMAG);
   END IF;
--------------------------------------------------------------------------------------------------------


----------------------------------------   /*REGISTROS 40 A 92*/   -------------------------------------
   V_CONTADOR := ARQUIVO_DMA_DETALHAMENTO (P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL,
                                           P_NRSEQARQMAG);
--------------------------------------------------------------------------------------------------------

END;
/


-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_DMA_BA','5.30.000'); END;
/

